/****************************************************************************
** Form implementation generated from reading ui file '..\client\ui-files\skill_dlg.ui'
**
** Created: Wed Jun 16 23:40:30 2004
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "skill_dlg.h"
#include "skills.h"
#include "../common/aoc_names.h"
#include "../common/aoc_version.h"
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qheader.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>


/* 
 *  Constructs a AOCSkillDlg which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
AOCSkillDlg::AOCSkillDlg( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QFrame( parent, name, modal, fl )
{
    if ( !name )
		setName( "AOCSkillDlg" );
    AOCSkillDlgLayout = new QVBoxLayout( this ); 
    AOCSkillDlgLayout->setSpacing( 4 );
    AOCSkillDlgLayout->setMargin( 6 );

    SkillFrame = new QGroupBox( this, "SkillFrame" );
    SkillFrame->setTitle( tr( "My Skills" ) );
    SkillFrame->setColumnLayout(0, Qt::Vertical );
    SkillFrame->layout()->setSpacing( 0 );
    SkillFrame->layout()->setMargin( 0 );
    SkillFrameLayout = new QGridLayout( SkillFrame->layout() );
    SkillFrameLayout->setAlignment( Qt::AlignTop );
    SkillFrameLayout->setSpacing( 4 );
    SkillFrameLayout->setMargin( 6 );

    SkillList = new QListView( SkillFrame, "SkillList" );
    SkillList->header()->setClickEnabled( FALSE );
    SkillList->header()->setResizeEnabled( FALSE );
	SkillList->addColumn( tr( "#" ) );
    SkillList->addColumn( tr( "Skill" ), 180 );
    SkillList->addColumn( tr( "Amount" ), 60 );
	SkillList->setAllColumnsShowFocus( TRUE );
	SkillList->setSorting( 0, TRUE );
    SkillList->setLineWidth( 1 );
    SkillFrameLayout->addMultiCellWidget( SkillList, 0, 0, 0, 2 );

    SkillBox = new QComboBox( FALSE, SkillFrame, "SkillBox" );
    SkillBox->setSizePolicy( QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::Fixed, SkillBox->sizePolicy().hasHeightForWidth() ) );
	for( int n = 0; n < Names.getSkills(); n++ )
	{
		SkillBox->insertItem( Names.getSkill( n ) );
	}

    SkillFrameLayout->addWidget( SkillBox, 1, 0 );

    SkillSpin = new QSpinBox( SkillFrame, "SkillSpin" );
    SkillSpin->setMaxValue( 4000 );
    SkillFrameLayout->addWidget( SkillSpin, 1, 1 );

    SetBtn = new QPushButton( SkillFrame, "SetBtn" );
    SetBtn->setText( tr( "&Set" ) );
    SkillFrameLayout->addWidget( SetBtn, 1, 2 );

    AOCSkillDlgLayout->addWidget( SkillFrame );

    // signals and slots connections
	connect( SkillBox, SIGNAL( activated(int) ), this, SLOT( selectSkill(int) ) );
	connect( SkillList, SIGNAL( selectionChanged(QListViewItem*) ), this, SLOT( selectSkill(QListViewItem*) ) );
    connect( SetBtn, SIGNAL( clicked() ), this, SLOT( setSkill() ) );

	updateSkills();
}

/*  
 *  Destroys the object and frees any allocated resources
 */
AOCSkillDlg::~AOCSkillDlg()
{
    // no need to delete child widgets, Qt does it all for us
}

void AOCSkillDlg::updateSkills()
{
	SkillList->clear();
	QListViewItem *item = 0;
	AOCSkill curItem;

	for( int n = 0; n < MySkills.getSkills(); n++ )
	{
		curItem = MySkills.getSkill( n );
		item = new QListViewItem( SkillList, item );
		item->setText( 0, tr( "%1" ).arg( curItem.Skill, 4 ) );
		item->setText( 1, Names.getSkill( curItem.Skill ) );
		item->setText( 2, tr( "%1" ).arg( curItem.Value ) );
	}
	selectSkill( 0 );
}

void AOCSkillDlg::selectSkill(QListViewItem*)
{
	if( QListViewItem* s = SkillList->selectedItem() )
	{
		AOCSkill skill = MySkills.getSkillByID( s->text( 0 ).toInt() );
		SkillBox->setCurrentItem( skill.Skill );
		SkillSpin->setValue( skill.Value );
	}
}

void AOCSkillDlg::selectSkill(int)
{
	int selSkill = SkillBox->currentItem();
	AOCSkill skill = MySkills.getSkillByID( selSkill );
	SkillSpin->setValue( skill.Value );
}

void AOCSkillDlg::setSkill()
{
	int selSkill = SkillBox->currentItem();
	MySkills.setSkill( selSkill, SkillSpin->value() );
	updateSkills();
}

