// skills.h: interface for the AOCMySkills class.
//
//////////////////////////////////////////////////////////////////////
#ifndef SKILLS_H
#define SKILLS_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <qvariant.h>

typedef struct
{
	Q_UINT32 Skill;
	Q_UINT16 Value;
} AOCSkill;

class AOCMySkills
{
public:
	AOCMySkills();
	virtual ~AOCMySkills();

	void loadData();
	void saveData();

	int getSkills();
	AOCSkill getSkill( int skill );
	AOCSkill getSkillByID( Q_UINT32 skill );
	int getSkillIndexByID( Q_UINT32 skill );
	void setSkill( Q_UINT32 skill, Q_UINT16 value );

protected:

	AOCSkill blankSkill();
	QValueList<AOCSkill> Skills;
};

extern AOCMySkills MySkills;

#endif // SKILLS_H
